package sun.misc;

public class RequestProcessor implements Runnable {
   private static Queue requestQueue;
   private static Thread dispatcher;

   public static void postRequest(Request var0) {
      lazyInitialize();
      requestQueue.enqueue(var0);
   }

   public void run() {
      lazyInitialize();

      while(true) {
         try {
            Object var1 = requestQueue.dequeue();
            if (var1 instanceof Request) {
               Request var2 = (Request)var1;

               try {
                  var2.execute();
               } catch (Throwable var3) {
               }
            }
         } catch (InterruptedException var4) {
         }
      }
   }

   public static synchronized void startProcessing() {
      if (dispatcher == null) {
         dispatcher = new Thread(new RequestProcessor(), "Request Processor");
         dispatcher.setPriority(7);
         dispatcher.start();
      }

   }

   private static synchronized void lazyInitialize() {
      if (requestQueue == null) {
         requestQueue = new Queue();
      }

   }
}
